package cn.wise.sc.cement.business.controller;


import cn.hutool.core.date.DateUtil;
import cn.wise.sc.cement.business.entity.QualityApply;
import cn.wise.sc.cement.business.model.BaseResponse;
import cn.wise.sc.cement.business.service.IQualityApplyService;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author ztw
 * @since 2020-10-12
 */
@Api(tags = "质量检测审批")
@Slf4j
@CrossOrigin
@RestController
@RequestMapping("/business/qualityApply")
public class QualityApplyController {

    final
    IQualityApplyService iQualityApplyService;

    public QualityApplyController(IQualityApplyService iQualityApplyService) {
        this.iQualityApplyService = iQualityApplyService;
    }

    @PostMapping("/apply")
    @ApiOperation("质量详情审核")
    public BaseResponse<Boolean> applyQuality(@RequestBody List<QualityApply> qualityApply) {
        boolean save = iQualityApplyService.saveBatch(qualityApply);
        if (save) {
            return BaseResponse.okData(true);
        } else {
            return BaseResponse.errorMsg("添加失败!");
        }
    }

    public static void main(String[] args) {
        List<QualityApply> list = new ArrayList<>();
        QualityApply qualityApply = new QualityApply();
        qualityApply.setCementCode("test");
        qualityApply.setCreateTime(LocalDate.now());
        qualityApply.setInputResult("[1,2,3,4]");
        qualityApply.setProjectId(1);
        qualityApply.setProjectName("test");
        qualityApply.setUserName("检测人");
        qualityApply.setSampleCode("001");
        qualityApply.setSampleForm("粉末");
        qualityApply.setSampleName("样品A");
        qualityApply.setTeams("[S,CO3,LiO2,H2Co3]");
        qualityApply.setTeamGroupId(1);
        QualityApply qualityApply1 = new QualityApply();
        qualityApply1.setCementCode("test");
        qualityApply1.setCreateTime(LocalDate.now());
        qualityApply1.setInputResult("[1,2,3,4]");
        qualityApply1.setProjectId(1);
        qualityApply1.setProjectName("test");
        qualityApply1.setUserName("检测人");
        qualityApply1.setSampleCode("001");
        qualityApply1.setSampleForm("粉末");
        qualityApply1.setSampleName("样品A");
        qualityApply1.setTeams("[S,CO3,LiO2,H2Co3]");
        qualityApply1.setTeamGroupId(1);
        list.add(qualityApply1);

        String ss = "[\"S\",\"CO3\",\"LiO2\",\"H2Co3\"]";
        list.add(qualityApply);
        List<String> a = new ArrayList<>();
        a.add("S");
        a.add("CO3");
        a.add("LiO2");
        a.add("H2Co3");
        System.out.println(JSON.toJSONString(a));
        System.out.println(JSON.toJSONString(list));
    }

    @PostMapping("/export")
    @ApiOperation("导出质量监控")
    public void exportQuality(String startDate, String endDate, HttpServletResponse response) {

        Date startParse = DateUtil.parse(startDate);
        Date endParse = DateUtil.parse(endDate);
        iQualityApplyService.exportQuality(startParse, endParse, response);
    }
}

